-- LOOPER.EX                                                

-- Still another program for generating colorful geometric patterns
-- Uses the NEIL graphics library
-- Mark K.Akita  12/14/00

without type_check

include neil.e
include misc.e
include get.e

constant FALSE=0,TRUE=1

object s1,s2,o1
atom n1,n2,an1,an2,an3,r,r2,rt,x,y,z,sx,sy
atom px,py,dy,d,aa1,aa2,ad1,ad2
integer NotDone,i1,c,cr,change
sequence ct

-- The initial values...
-- a1,a2 =current angle2
-- n1=multiplier
-- x,y=current x and y positions
-- sx,sy=screen x and y positions

-- Set the graphics mode to 640x480x16bit
i1=vesa_mode(800,600,16)

-- clear the screen and set up virtual screens
s1=virtual_screen(800,600)
s2=virtual_screen(800,600)
do_command(blit,screen,{s2,0,0})
clear_screen()


procedure init()
-- set the initial parameters

    fg_color(#0000FF)
    n1=rand(5)+10
    n2=rand(3)
    rt=200
    aa1=0
    aa2=0
    ad1=(rand(5)+4)/10
    ad2=(rand(4)+5)/100
    change=0
    ct=repeat(0,16)
    cr=rand(8)
    if cr=1 then 
        c=1    
    end if
    if cr=2 then 
        c=#101    
    end if
    if cr=3 then 
        c=#100    
    end if
    if cr=4 then 
        c=#10100    
    end if
    if cr=5 then 
        c=#10000    
    end if
    if cr=6 then 
        c=#10001    
    end if
    if cr=7 then
        c=#10101    
    end if
    if cr=8 then
        ct[1]=#FF0000
        ct[2]=#FFBE00
        ct[3]=#FF5F00
        ct[4]=#FF8F00
        ct[5]=#FFBF00
        ct[6]=#DFDF00
        ct[7]=#BFFF00
        ct[8]=#5FFF00
        ct[9]=#00FF00
        ct[10]=#009F5F
        ct[11]=#003FBF
        ct[12]=#001FDF
        ct[13]=#7F00FF
        ct[14]=#9F00BF
        ct[15]=#BF007F
        ct[16]=#DF003F
    else
        for i=1 to 16 do
            ct[i]=((i*16)-1)*c          
        end for
    end if
    
end procedure

-- start the main loop
init()
NotDone = TRUE

if i1 then
    NotDone = FALSE
    restore_mode()
    puts(1,"Whoops, this program runs in 800x600x16bit resolution\n")           
    o1=gets(0)
end if

while NotDone do

    change=change+1
    if change>500 then
        init()    
    end if

    an1=aa1
    an2=aa2
    an3=aa2
    c=0
    for i=1 to n1 do
        for j=0 to 32 do
            an1=an1+PI/16
            an2=an2+PI/(16*n1)
            an3=an3+PI/(16*n1/n2)
            r=cos(an3)*rt
            z=sin(an2)*r
            r2=cos(an2)*r
            x=cos(an1)*r2
            y=sin(an1)*r2
            dy=y+300
            d=sqrt((dy*dy)+(x*x)+(z*z))
            sx=(x*350)/d
            sx=floor(sx+400)
            sy=(z*350)/d
            sy=floor(sy+300)
            if i=1 and j=0 then
                px=sx
                py=sy    
            end if
            draw_line(s1,ct[i+1],{{sx,sy},{px,py}})
            px=sx
            py=sy
            c=c+1
            c=remainder(c,16)    
        end for
    end for
    
    aa1=aa1+ad1
    aa2=aa2+ad2
        
    do_command(blit,s1,{screen,0,0})
    do_command(blit,s2,{s1,0,0})

--Test for a key
    i1 = get_key()
    if i1!=-1 then
        NotDone = FALSE
    end if
    
    mouse()
    if mouse_b !=0 then
        NotDone = FALSE
    end if

end while

free_screen(s1)
free_screen(s2)
restore_mode()

